function varargout = RecSomGUI(varargin)
% RECSOMGUI M-file for RecSomGUI.fig
%      RECSOMGUI, by itself, creates a new RECSOMGUI or raises the existing
%      singleton*.
%
%      H = RECSOMGUI returns the handle to a new RECSOMGUI or the handle to
%      the existing singleton*.
%
%      RECSOMGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RECSOMGUI.M with the given input arguments.
%
%      RECSOMGUI('Property','Value',...) creates a new RECSOMGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before RecSomGUI_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to RecSomGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES
%
% CLASSE Project
% Created by Edgar Ferreira - FCTUC
% edgars@student.dei.uc.pt / edgar.bajouca@gmail.com
% Updated April 20, 2007
%
% Copyright (C) 2007 Edgar Ferreira  FCTUC Coimbra, Portugal
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.

% Edit the above text to modify the response to help RecSomGUI

% Last Modified by GUIDE v2.5 23-Mar-2007 16:57:57

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @RecSomGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @RecSomGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%% STRUCTURES DEFINITION
% 
% - plot:               structure containing plot variables
% - rawData:            structure containing data from Excel file
% - labels:             structure containing labels
% - reducedData:        structure containing reduced data, if it exists
% - clusteringData:     structure containing clustering data and parameters

%% --- Executes just before RecSomGUI is made visible.
function RecSomGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to RecSomGUI (see VARARGIN)

% Get input variables and structures
in_vars = varargin;
input = in_vars{1};
if isfield(input,'rawData')
    handles.rawData = input.rawData;
end
handles.labels = input.labels;
handles.type = input.som_data;

% Get input parameters for reduced data
if handles.type==1
    handles.reducedData = input.reducedData;
    handles.data=input.somData;        %reduced matrix
    text='Reduced matrix';

    % Display Info
    set(handles.info,'String',strvcat('INPUT DATA INFO:',char(handles.reducedData.textToLog), ' ','RECURSIVE SOM INFO:'));

% Get input parameters for original data
else
    handles.data=handles.rawData.original;   % original matrix
    text='Original data';
    
    % Display Info
    set(handles.info,'String','RECURSIVE SOM INFO:');
end

handles.sD=som_data_struct(handles.data);   % create data structure
sTo=som_topol_struct(handles.sD);           % create topology structure (only to get parameters: msize)

% write information
set(handles.mapSize,'String',['[' num2str(sTo.msize) ']']);
str=get(handles.info,'String');
set(handles.info,'String',strvcat(str,[text ' loaded. Please select Study Method.']));

% set default status of objects
set([handles.textWeights handles.plotWeights handles.textPlot handles.plotSym],'Enable','off');
set([handles.textNr handles.nrCluster handles.addCluster handles.remCluster handles.check],'Enable','off');
set([handles.simulation],'Enable','off');
set([handles.plotFigure],'Enable','off');
set([handles.textType handles.radioRec handles.radioSD],'Enable','on');
set([handles.norm],'Enable','on');
set([handles.textMap handles.mapSize],'Enable','on');
set([handles.textNeig handles.neig],'Enable','on');
set([handles.textLat handles.lat],'Enable','on');
set([handles.textEpochs handles.epochs handles.train],'Enable','on');
      
set(handles.figureRSOM,'userdata',handles.axesRSOM)

% Choose default command line output for RecSomGUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes RecSomGUI wait for user response (see UIRESUME)
%uiwait(handles.figureRSOM);


% --- Outputs from this function are returned to the command line.
function varargout = RecSomGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes when user attempts to close figureRSOM.
function figureRSOM_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figureRSOM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);

%% METHOD SELECTION PANEL

%% --- Executes on selection change in methodSelection.
function methodSelection_Callback(hObject, eventdata, handles)
% hObject    handle to methodSelection (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns methodSelection contents as cell array
%        contents{get(hObject,'Value')} returns selected item from methodSelection

val=get(handles.methodSelection,'Value');

switch val  
   case 1   %new train
      set([handles.textWeights handles.plotWeights handles.textPlot handles.plotSym],'Enable','off');
      set([handles.textNr handles.remCluster handles.nrCluster handles.addCluster handles.check],'Enable','off');
      set([handles.simulation],'Enable','off');
      set([handles.textType handles.radioRec handles.radioSD],'Enable','on');
      set([handles.norm],'Enable','on');
      set([handles.textMap handles.mapSize],'Enable','on');
      set([handles.textNeig handles.neig],'Enable','on');
      set([handles.textLat handles.lat],'Enable','on');
      set([handles.textEpochs handles.epochs handles.train],'Enable','on');
      if (get(handles.norm,'Value') == get(handles.norm,'Max'))   %if selected
          set([handles.norm_opt],'Enable','on');
      end
    case 2  %load train
        % Load Mat-File containing network
        [filename, pathname] = uigetfile({'*.mat', 'MAT-Files (*.mat)';'*.*','All Files (*.*)'},'Select a Recursive SOM Network to load');

        % If "Cancel" is selected then return
        if isequal([filename,pathname],[0,0])
            set(handles.methodSelection,'value',1);
            return
            % Otherwise construct the fullfilename and load the selected MAT-File
        else
            file = fullfile(pathname,filename);
            handles.filename=filename;   %needed to write in info box
            struc=open(file);
            names = fieldnames(struc);  %get list off arrays in mat-file
            
            foundNet=0;         %found = false
            % Load variables
            aux=find(strcmp(names,'clusteringData'));
            if aux>0
                clusteringData = struc.(names{aux});
                if isfield(clusteringData,'net')
                    foundNet=1;    %found net
                    net=clusteringData.net;
                    sD=clusteringData.sD;
                    output=clusteringData.output;
                    index=clusteringData.index;
                end
            end
           
            % Check needed variables
            if foundNet==1
                % Load structures
                aux=find(strcmp(names,'rawData'));
                if aux>0
                    handles.rawData = struc.(names{aux});
                end
                aux=find(strcmp(names,'labels'));
                if aux>0
                    handles.rawData = struc.(names{aux});
                end
                aux=find(strcmp(names,'reducedData'));
                if aux>0
                    handles.type = 1;
                    handles.reducedData = struc.(names{aux});
                else
                    handles.type = 2;   %no data from dimension reduction
                end
                
                % Store structure
                handles.clusteringData = clusteringData;
                
                % Store common variables
                handles.Net=net;
                handles.sD=sD;

                % Check loaded dimensions
                loadDim=net.Dim.INNum;
                currentDim=size(handles.data,2);
                if loadDim==currentDim
                    % Reset Plot
                    cla
                    handles.plot.clusters=[];
                    handles.colors=[];
                    for i=2:8
                        lineName=['line' num2str(i)];
                        line=findobj('parent',gca,'tag',lineName);
                        delete(line);
                    end

                    % Plot Output
                    ind=1:length(output);
                    plot(ind,output,'k')
                    title([net.RSOM.RSOMType '  -  Dimension: [' num2str(net.Dim.RSOMSize) ']  -  Epochs: ' num2str(net.State.MaxEpoch)])
                    hold on

                    % Plot loaded lines
                    haxis=get(gcf,'userdata');
                    nrCluster=clusteringData.parameters.nrClusters;
                    cm=colormap;
                    if nrCluster>1
                        for i=2:nrCluster
                            k=min(floor((64/6)*i-(128/6)+1),64);  %divide colormap in 7 colors and start at index 1
                            color=cm(k,:);
                            lineName=['line' num2str(i)];
                            h=MovableLine(haxis,lineName,'h','','',color,index(i-1));
                            handles.plot.lastLine=lineName;
                        end
                    end
                    
                    % Check nr of clusters
                    if nrCluster==8
                        set(handles.addCluster,'Enable','off');
                    elseif nrCluster==1
                        set(handles.remCluster,'Enable','off');
                    end
               
                    % Set datacursor labels
                    dcm_obj = datacursormode;
                    set(dcm_obj,'DisplayStyle','datatip','SnapToDataVertex','on','Enable','on','UpdateFcn',{@myupdatefcn,handles.labels})
                    
                    % Save plot variables
                    handles.plot.nrCluster=nrCluster;
                    handles.plot.output=output;
                    handles.plot.index=index;
                    
                    % Activate pointer
                    datacursormode off
                    zoom off
                    plotedit off
                    rotate3d off
                    
                    % Set enable objects
                    set([handles.textWeights handles.plotWeights handles.textPlot handles.plotSym],'Enable','on');
                    set([handles.textNr handles.remCluster handles.nrCluster handles.addCluster handles.check],'Enable','on');
                    set([handles.simulation],'Enable','on');
                    set([handles.plot_menu handles.plotFigure],'Enable','on');
                    set(handles.nrCluster,'String',num2str(nrCluster));
                    
                    % Set disable objects
                    set([handles.textType handles.radioRec handles.radioSD],'Enable','off');
                    set([handles.norm handles.norm_opt],'Enable','off');
                    set([handles.textMap handles.mapSize],'Enable','off');
                    set([handles.textNeig handles.neig],'Enable','off');
                    set([handles.textLat handles.lat],'Enable','off');
                    set([handles.textEpochs handles.epochs handles.train],'Enable','off');

                else
                    set(handles.methodSelection,'value',1);
                    errordlg('Loaded network doesnt match current data dimensions','Incorrect Network','modal')
                    return
                end
            else
                set(handles.methodSelection,'value',1);
                errordlg('File doesn`t contain necessary variables','Incorrect Selection','modal')
                return
            end
        end

    otherwise
        %nothing
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function methodSelection_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% RECURSIVE SOM TRAIN PANEL

%% --- Executes on button press in radioRec.
function radioRec_Callback(hObject, eventdata, handles)
% hObject    handle to radioRec (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radioRec
set(handles.radioRec,'Value',1.0);
set(handles.radioSD,'Value',0.0);

%% --- Executes on button press in radioSD.
function radioSD_Callback(hObject, eventdata, handles)
% hObject    handle to radioSD (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radioSD
set(handles.radioRec,'Value',0.0);
set(handles.radioSD,'Value',1.0);

%% --- Executes on button press in norm.
function norm_Callback(hObject, eventdata, handles)
% hObject    handle to norm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if (get(handles.norm,'Value') == get(handles.norm,'Max'))   %if selected
    set(handles.norm_opt,'Enable','on');
    % On each callback, map size must be updated
    str=get(handles.norm_opt,'String');
    val=get(handles.norm_opt,'Value');
    method=lower(str{val});
    sD_temp=som_normalize(handles.sD,method);   % temporary sD predicting selected normalization
    sTo=som_topol_struct(sD_temp);              % create topology structure (only to get parameters: msize)
    set(handles.mapSize,'String',['[' num2str(sTo.msize) ']']);  %update msize
else                                                        %if not selected
    set(handles.norm_opt,'Enable','off');
    % On each callback, map size must be updated (to the original)
    sTo=som_topol_struct(handles.sD);              % create topology structure (only to get parameters: msize)
    set(handles.mapSize,'String',['[' num2str(sTo.msize) ']']);  %update msize
end

%% --- Executes on selection change in norm_opt.
function norm_opt_Callback(hObject, eventdata, handles)
% hObject    handle to norm_opt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% On each callback, map size must be updated
str=get(handles.norm_opt,'String');
val=get(handles.norm_opt,'Value');
method=lower(str{val});
sD_temp=som_normalize(handles.sD,method);   % temporary sD predicting selected normalization
sTo=som_topol_struct(sD_temp);              % create topology structure (only to get parameters: msize)
set(handles.mapSize,'String',['[' num2str(sTo.msize) ']']);  %update msize

% --- Executes during object creation, after setting all properties.
function norm_opt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to norm_opt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% RecSOM Train Static Parameters

% --- Executes during object creation, after setting all properties.
function mapSize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mapSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function neig_CreateFcn(hObject, eventdata, handles)
% hObject    handle to neig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function lat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function epochs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to epochs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% --- Executes on button press in train.
function train_Callback(hObject, eventdata, handles)
% hObject    handle to train (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(hObject,'Enable','Off')
pause(0.001);

% Get Data
data=handles.data;

% Normalization if selected
if (get(handles.norm,'Value') == 1)
    str=get(handles.norm_opt,'String');
    val=get(handles.norm_opt,'Value');
    method=lower(str{val});
    
    handles.sD=som_data_struct(data);   % reset data structure
    handles.sD.data=data;   % recover original data before normalization
    handles.sD=som_normalize(handles.sD,method);
    data=handles.sD.data;
    
    str=get(handles.info,'String');
    set(handles.info,'String',strvcat(str,['Data normalized.']));
end

% Get parameters
type='RecSOM';
if (get(handles.radioSD,'Value')) == 1
    type='SOMSD';
end                                                 %Network Type
msize=str2num(get(handles.mapSize,'String'));       %Map Size
neig=str2double(get(handles.neig,'String'));        %Neighborhood
lat='Hex';
if (get(handles.lat,'Value')) == 2
    lat='Grid';
end                                                 %Lattice
MaxEpoch=str2double(get(handles.epochs,'String'));  %Epochs

% Create Network
Net = CreateNetRSOM(size(data,2) , msize ,'RSOMType' , type, 'RSOMTopo', lat , 'RSOMNeiFunP' , neig , 'RSOMUnSLFun' , 'RSOMHebbV01' , 'ShowMessages' , 0);

% Training RSOM Network
Epoch = 1;
Net.State.MaxEpoch = MaxEpoch;

while Epoch <= MaxEpoch
    Net.State.Epoch = Epoch;
    Net = SimNetRSOM(Net , data');
    Net.State.RSOMState = zeros(size(Net.State.RSOMState , 1) , 1);
    Epoch = Epoch + 1;
end

% Simulating with training data
Net.Learn.RSOMUnSLFun   = 'None';

W=Net.W.WINRSOM;            %weights
A=zeros(length(data),1);    %output
ind=1:length(data);

%for each input
for i=1:length(data)
    aTemp=0;
    pTemp=data(i,:);
    for j=1:size(W,2)
        wTemp=W(:,j);
        aTemp=aTemp + pTemp*wTemp;
    end
    A(i)=aTemp;
end

%normalization
maximum = max(A);
Output = A/maximum;
Net.Max = maximum;  %save maximum for future load

% Update Info
str=get(handles.info,'String');
set(handles.info,'String',strvcat(str,'RSOM trained. Output for training data plotted.','Add and move threshold lines to define cluster limits.'));

%Reset Plot
cla
handles.plot.clusters=[];
handles.plot.colors=[];
handles.plot.nrCluster=1;
for i=2:8
    lineName=['line' num2str(i)];
    line=findobj('parent',gca,'tag',lineName);
    delete(line);
end

% Plot Output
plot(ind,Output,'k')
title([Net.RSOM.RSOMType '  -  Dimension: [' num2str(Net.Dim.RSOMSize) ']  -  Epochs: ' num2str(Net.State.MaxEpoch)])
hold on

% Set datacursor labels
dcm_obj = datacursormode;
set(dcm_obj,'DisplayStyle','datatip','SnapToDataVertex','on','Enable','on','UpdateFcn',{@myupdatefcn,handles.labels})


% Update GUI
set([handles.textWeights handles.plotWeights handles.textPlot handles.plotSym],'Enable','on');
set([handles.textNr handles.nrCluster handles.addCluster handles.check],'Enable','on');
set(handles.nrCluster,'String','1');
set(handles.remCluster,'Enable','off');
set([handles.plot_menu handles.save_menu],'Enable','on');
set([handles.plotFigure],'Enable','on');

%Save needed variables
handles.Net=Net;
handles.plot.output=Output;
guidata(hObject, handles); 
set(hObject,'Enable','On')

%% RECURSIVE SOM SIMULATION PANEL

%% --- Executes on button press in plotWeights.
function plotWeights_Callback(hObject, eventdata, handles)
% hObject    handle to plotWeights (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Net=handles.Net;
W=Net.W.WINRSOM;

str=get(handles.plotSym, 'String');
val=get(handles.plotSym, 'Value');
symbol=str{val};

figure('name','Network Weights')
if size(W,1) == 2
    plot(W(1,:),W(2,:),symbol)
elseif size(W,1) == 3
    plot3(W(1,:),W(2,:),W(3,:),symbol)
else
    W=pcaproj(W',3)';
    plot3(W(1,:),W(2,:),W(3,:),symbol)
end
grid on
title([Net.RSOM.RSOMType ' Weights  -  Dimension: [' num2str(Net.Dim.RSOMSize) ']  -  Epochs: ' num2str(Net.State.MaxEpoch)])


% --- Executes during object creation, after setting all properties.
function plotSym_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plotSym (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function nrCluster_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nrCluster (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% --- Executes on button press in addCluster.
function addCluster_Callback(hObject, eventdata, handles)
% hObject    handle to addCluster (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Update nr of clusters
nrClust=str2num(get(handles.nrCluster,'String'))+1;
set(handles.nrCluster,'String',num2str(nrClust));
if nrClust==8
    set(handles.addCluster,'Enable','off');
end
set(handles.remCluster,'Enable','on');

%Get axes context and draw a new line
haxis=get(gcf,'userdata');
cm=colormap;
k=min(floor((64/6)*nrClust-(128/6)+1),64);  %divide colormap in 7 colors and start at index 1
color=cm(k,:);
lineName=['line' num2str(nrClust)];
h=MovableLine(haxis,lineName,'h','','',color);
handles.plot.lastLine=lineName;

%Activate pointer
datacursormode off
zoom off
plotedit off
rotate3d off

% Save plot variables
handles.plot.nrCluster=nrClust;

guidata(hObject, handles);

%% --- Executes on button press in remCluster.
function remCluster_Callback(hObject, eventdata, handles)
% hObject    handle to remCluster (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Update nr of clusters
nrClust=str2num(get(handles.nrCluster,'String'))-1;
set(handles.nrCluster,'String',num2str(nrClust));
if nrClust==1
    set(handles.remCluster,'Enable','off');
end
set(handles.addCluster,'Enable','on');

%Find last line and delete it
line=findobj('parent',gca,'tag',handles.plot.lastLine);
delete(line);
handles.plot.lastLine=['line' num2str(nrClust)];

% Save plot variables
handles.plot.nrCluster=nrClust;

guidata(hObject, handles);

%% --- Executes on button press in check.
function check_Callback(hObject, eventdata, handles)
% hObject    handle to check (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

updateClusters(hObject,handles);

%% --- Executes on button press in simulation.
function simulation_Callback(hObject, eventdata, handles)
% hObject    handle to simulation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(hObject,'Enable','Off')
pause(0.001);
% Get Network and data to simule
Net=handles.Net;
data=handles.data;
sD=handles.sD;

% Normalize data columns with loaded parameters
if ~isempty(sD.comp_norm{1,1})
    method=sD.comp_norm{1,1}.method;
    switch method
        case 'range'
            for i=1:size(data,2)
                params=sD.comp_norm{i,1}.params;
                data(:,i)=(data(:,i) - params(1))/params(2);
            end
        case 'log'
            for i=1:size(data,2)
                params=sD.comp_norm{i,1}.params;
                data(:,i)=log(data(:,i) - params(1) + 1);
            end
        case 'var'
            for i=1:size(data,2)
                params=sD.comp_norm{i,1}.params;
                data(:,i)=(data(:,i) - params(1))/params(2);
            end
        otherwise
            data=handles.data;
    end
end

% Simulation
Net.Learn.RSOMUnSLFun = 'None';

W=Net.W.WINRSOM;            %weights
A=zeros(length(data),1);    %output
ind=1:length(data);

%for each input
for i=1:length(data)
    aTemp=0;
    pTemp=data(i,:);
    for j=1:size(W,2)
        wTemp=W(:,j);
        aTemp=aTemp + pTemp*wTemp;
    end
    A(i)=aTemp;
end

%normalization of output
Output=A/Net.Max;

% Update Info
str=get(handles.info,'String');
set(handles.info,'String',strvcat(str,'RSOM simulated.'));

%Reset Plot
cla
handles.plot.clusters=[];
handles.plot.colors=[];
for i=2:8
    lineName=['line' num2str(i)];
    line=findobj('parent',gca,'tag',lineName);
    delete(line);
end

% Plot Output
plot(ind,Output,'k')
title(['Simulation  -  ' Net.RSOM.RSOMType '  -  Dimension: [' num2str(Net.Dim.RSOMSize) ']  -  Epochs: ' num2str(Net.State.MaxEpoch)])
hold on

% Set datacursor labels
dcm_obj = datacursormode;
set(dcm_obj,'DisplayStyle','datatip','SnapToDataVertex','on','Enable','on','UpdateFcn',{@myupdatefcn,handles.labels})

% Plot loaded lines
haxis=get(gcf,'userdata');
nrCluster=handles.clusteringData.parameters.nrClusters;
cm=colormap;
if nrCluster>1
    for i=2:nrCluster
        k=min(floor((64/6)*i-(128/6)+1),64);  %divide colormap in 7 colors and start at index 1
        color=cm(k,:);
        lineName=['line' num2str(i)];
        h=MovableLine(haxis,lineName,'h','','',color,handles.plot.index(i-1));
        handles.plot.lastLine=lineName;
    end
end

% Update GUI
set([handles.plot_menu handles.save_menu],'Enable','on');

%Save needed variables
handles.plot.output=Output;

guidata(hObject, handles); 

set(hObject,'Enable','On')
%% INFORMATION AND PLOT AREAS

% --- Executes during object creation, after setting all properties.
function info_CreateFcn(hObject, eventdata, handles)
% hObject    handle to info (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% --- Executes on button press in plotFigure.
function plotFigure_Callback(hObject, eventdata, handles)
% hObject    handle to plotFigure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[hObject handles] = updateClusters(hObject,handles);

Output=handles.plot.output;
clusters=handles.plot.clusters;
colors=handles.plot.colors;
ind=1:length(Output);
nr=max(clusters);
Net=handles.Net;

figure('name','Recursive SOM Clustering')
plot(ind,Output,'k')
title([Net.RSOM.RSOMType '  -  Dimension: [' num2str(Net.Dim.RSOMSize) ']  -  Epochs: ' num2str(Net.State.MaxEpoch) '  -  ' num2str(nr) ' Clusters'])
hold on

% Set datacursor labels
dcm_obj = datacursormode;
set(dcm_obj,'DisplayStyle','datatip','SnapToDataVertex','on','Enable','on','UpdateFcn',{@myupdatefcn,handles.labels})

for i = 1:nr
    color=colors(i,:);
    clust = find(clusters==i);     % return indexes for each cluster
    plot(ind(clust),Output(clust),'x','color',color);                  % plot current cluster
end
hold off

%% MENU FUNCTIONS
% --------------------------------------------------------------------
function save_xls_Callback(hObject, eventdata, handles)
% hObject    handle to save_xls (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[hObject handles] = updateClusters(hObject,handles);

% Variables to send to Save GUI
if handles.type == 1
    if size(handles.clusteringData.sD.data,2)==3
        send.header = {'1st Dimension' '2nd Dimension' '3rd Dimension'};
    else
        send.header = {'1st Dimension' '2nd Dimension'};
    end
else
    send.header = handles.labels.varNames;
end

send.labels = handles.labels;
send.data = handles.clusteringData.sD.data;
send.clusters = handles.clusteringData.clusters;
send.text = [handles.clusteringData.method ' Clustering'];
send.output = handles.clusteringData.output;

input=SaveXls(send);   % run Save GUI

if input==1
    str=get(handles.info,'String');
    set(handles.info,'String',strvcat(str,'Results saved to Excel File.'));
end

% --------------------------------------------------------------------
function save_mat_Callback(hObject, eventdata, handles)
% hObject    handle to save_mat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[hObject handles] = updateClusters(hObject,handles);

[a,b]=uiputfile('*.mat','Save Data Matrix and Clustering Results');

if isequal([a,b],[0,0])
    return
else
    c=strcat(b,a);
    % Get structures to save
    if isfield(handles,'rawData')
        rawData = handles.rawData;
    end
    labels = handles.labels;
    if handles.type == 1
        reducedData = handles.reducedData;
    end
    clusteringData = handles.clusteringData;

    % Save all structures:
    if handles.type == 1
        if isfield(handles,'rawData')
            save (c,'rawData','labels','reducedData','clusteringData')
        else
            save (c,'labels','reducedData','clusteringData')
        end
    else
        if isfield(handles,'rawData')
            save (c,'rawData','labels','clusteringData')
        else
            save (c,'labels','clusteringData')
        end
    end
    
    % Update Info
    str=get(handles.info,'String');
    set(handles.info,'String',strvcat(str,['Results saved to MAT-File: ' a]));
end

% --------------------------------------------------------------------
function save_work_Callback(hObject, eventdata, handles)
% hObject    handle to save_work (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[hObject handles] = updateClusters(hObject,handles);

% Save all structures:
if isfield(handles,'rawData')
    assignin('base','rawData', handles.rawData);
end
assignin('base','labels', handles.labels);
if handles.type == 1
    assignin('base','reducedData', handles.reducedData);
end
assignin('base','clusteringData', handles.clusteringData);

% Update Info
str=get(handles.info,'String');
set(handles.info,'String',strvcat(str,'Results sent to Workspace.'));


% --------------------------------------------------------------------
function menu_pointer_Callback(hObject, eventdata, handles)
% hObject    handle to menu_pointer (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

datacursormode off
zoom off
plotedit off
rotate3d off

% --------------------------------------------------------------------
function menu_datacursor_Callback(hObject, eventdata, handles)
% hObject    handle to menu_datacursor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

datacursormode on

% --------------------------------------------------------------------
function menu_zoom_Callback(hObject, eventdata, handles)
% hObject    handle to menu_zoom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

zoom on

% --------------------------------------------------------------------
function menu_editor_Callback(hObject, eventdata, handles)
% hObject    handle to menu_editor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

plotedit on

% --------------------------------------------------------------------
function menu_rotate_Callback(hObject, eventdata, handles)
% hObject    handle to menu_rotate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

rotate3d on

%% SUB-FUNCTIONS AREA

%% --- SubFunction to update clustering representation on axes
function [hObject handles] = updateClusters(hObject, handles)
% hObject    handle to sender
% handles    structure with handles and user data (see GUIDATA)

%get nr of clusters and initialize variables
nr=handles.plot.nrCluster;
ind=[];
colorsTemp=[];
out=handles.plot.output;

%get y-position and color of all lines
for i=2:nr
    lineName=['line' num2str(i)];
    line=findobj('parent',gca,'tag',lineName);
    y=get(line,'ydata');
    ind(i-1)=y(1);
    color=get(line,'color');
    colorsTemp(i-1,:)=color;
end

%order the index vector
if nr>1
    index=zeros(length(ind),1);
    colors=zeros(size(colorsTemp));
    for k=1:length(ind)
        [minimum i]=min(ind);
        index(k)=minimum;
        ind(i)=max(ind)+1;
        colors(k,:)=colorsTemp(i,:);
    end
    colors=[[0 0 0];colors];
else
    index=[];
    colors=[0 0 0];
end

%get axes context and data to plot
haxis=get(gcf,'userdata');
axes(haxis);

clusters=zeros(length(out),1);
ind=1:length(out);

if nr==1
    clusters=ones(length(out),1);
    plot(ind,out,'kx');    % plot current cluster
else    
    for i = 1:nr
        color=colors(i,:);
        if i==1
            clust = find(out<=index(i));                    % return indexes for each cluster
        elseif i==nr
            clust = find(out>index(i-1));                   % return indexes for each cluster
        else
            clust = find(out<=index(i) & out>index(i-1));   % return indexes for each cluster
        end
        clusters(clust)=i;
        plot(ind(clust),out(clust),'x','color',color);    % plot current cluster
    end
end

% Save structures
handles.clusteringData.type = 'rsom';
handles.clusteringData.method = handles.Net.RSOM.RSOMType;
handles.clusteringData.clusters = clusters;
handles.clusteringData.parameters.nrClusters = nr;
handles.clusteringData.parameters.dimension = size(handles.data,2);
handles.clusteringData.net = handles.Net;
handles.clusteringData.sD = handles.sD;
handles.clusteringData.output = handles.plot.output;
handles.clusteringData.index = index;

handles.plot.clusters=clusters;
handles.plot.colors=colors;
handles.plot.index=index;
guidata(hObject, handles);

return

%% --- SubFunction to set datacursor information
function txt = myupdatefcn(empt,event_obj,labels)
pos = get(event_obj,'DataIndex');

nrOfLabels = length(labels.header);
txt=cell(1,nrOfLabels);
for i=1: nrOfLabels
    aux = [char(labels.header(i)) ': ' char(labels.(['Label_' num2str(i)])(pos))];
    txt(i) = {aux};
end
