function varargout = SaveXls(varargin)
% SaveXls M-file for SaveXls.fig
%      SaveXls, by itself, creates a new SaveXls or raises the existing
%      singleton*.
%
%      H = SaveXls returns the handle to a new SaveXls or the handle to
%      the existing singleton*.
%
%      SaveXls('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SaveXls.M with the given input arguments.
%
%      SaveXls('Property','Value',...) creates a new SaveXls or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before SaveXls_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to SaveXls_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES
%
% CLASSE Project
% Created by Edgar Ferreira - FCTUC
% edgars@student.dei.uc.pt / edgar.bajouca@gmail.com
% Updated April 20, 2007
%
% Copyright (C) 2007 Edgar Ferreira  FCTUC Coimbra, Portugal
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

% Edit the above text to modify the response to help SaveXls

% Last Modified by GUIDE v2.5 28-Nov-2006 18:42:34

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @SaveXls_OpeningFcn, ...
                   'gui_OutputFcn',  @SaveXls_OutputFcn, ...
                   'gui_LayoutFcn',  @SaveXls_LayoutFcn, ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before SaveXls is made visible.
function SaveXls_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to SaveXls (see VARARGIN)

% get inputs
in_vars=varargin;
handles.input=in_vars{1};
set(handles.sheet,'String',handles.input.text);

% Choose default command line output for SaveXls
handles.output = 0;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes SaveXls wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = SaveXls_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

delete(handles.figure1)


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.output = 0;
if isequal(get(handles.figure1, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    uiresume(handles.figure1);
else
    % The GUI is no longer waiting, just close it
    delete(handles.figure1);
end


function dest_Callback(hObject, eventdata, handles)
% hObject    handle to dest (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dest as text
%        str2double(get(hObject,'String')) returns contents of dest as a double


% --- Executes during object creation, after setting all properties.
function dest_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dest (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in browse.
function browse_Callback(hObject, eventdata, handles)
% hObject    handle to browse (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isfield(handles.input,'nn_output')
    [a,b]=uiputfile('*.xls','Save Learning Results');
else
    [a,b]=uiputfile('*.xls','Save Clustering Results');
end

if isequal([a,b],[0,0])
    return
else
    set(handles.dest,'String',strcat(b,a));
    set([handles.text2 handles.text3 handles.sheet handles.cell handles.save],'Enable','on');
end


function sheet_Callback(hObject, eventdata, handles)
% hObject    handle to sheet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sheet as text
%        str2double(get(hObject,'String')) returns contents of sheet as a double


% --- Executes during object creation, after setting all properties.
function sheet_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sheet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cell_Callback(hObject, eventdata, handles)
% hObject    handle to cell (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cell as text
%        str2double(get(hObject,'String')) returns contents of cell as a double


% --- Executes during object creation, after setting all properties.
function cell_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cell (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in save.
function save_Callback(hObject, eventdata, handles)
% hObject    handle to save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get parameters:
str1 = get(handles.dest,'String');
str2 = get(handles.sheet,'String');
str3 = get(handles.cell,'String');

% if(handles.input.save_method==2)   %from RecSOM
%     nodes=handles.input.clusters;  %get clustering result
%     data=handles.input.Output;     %get net output
% else
%     nodes=handles.input.nodes;     %get clustering result
%     data=handles.input.data;       %get original data
% end

% Get data to save
eq1=strcmp(handles.input.input,'first_clustering');
eq2=strcmp(handles.input.input,'second_clustering');

if isfield(handles.input,'classification')
    classification = handles.input.classification; % get nn result
    data = handles.input.data;          %get learning data
elseif eq1==1
    data=handles.input.data;
elseif eq2==1
    clusters = handles.input.clusters;  %get clustering result
    data = handles.input.data;          %get original data 
% else
%     clusters = handles.input.clusters;  %get clustering result
%     data = handles.input.data;          %get original data
end

% Build cell matrix to export to Excel
array=[];
% Insert labels
for i=1:length(handles.input.labels.header)
    header = handles.input.labels.header(i);
    label = handles.input.labels.(['Label_' num2str(i)]);
    % Label must be a column vector
    if size(label,1)==1
        label = label';
    end
    % Insert header
    label = [header;label];
    array = [array label];
end

% Insert data
if eq1==1
    array= data;
elseif eq2==1
    data = num2cell(data);
    data = [handles.input.header;data];
    array = [array data];       
% else
%     data = num2cell(data);
%     data = [handles.input.header;data];
%     array = [array data];
end

if isfield(handles.input,'classification')
    % Insert classes and nn output
    empty = cell(length(classification.classes)+1,1);
    array = [array empty];
    output = num2cell(classification.raw);
    if size(output,2)>1
        output_titles={};
        for i=1:size(output,2)
            output_titles{end+1}=['Output' int2str(i)];
        end
        output = [output_titles;output];
    else
        output = [{'Output'};output];
    end
    array = [array output];
    classes=num2cell(classification.classes);
    classes = [{'Class'};classes];
    array = [array classes];
    
elseif eq1==1
    array=data;
elseif eq2==1
    % Insert clusters (and Output for RecSOM)
    empty = cell(length(clusters)+1,1);
    array = [array empty];
    if isfield(handles.input,'output')
        output = num2cell(handles.input.output);
        output = [{'Output'};output];
        array = [array output];
    end
    clusters = num2cell(clusters);
    clusters = [{'Cluster'};clusters];
    array = [array clusters];
    
% else
%     % Insert clusters (and Output for RecSOM)
%     empty = cell(length(clusters)+1,1);
%     array = [array empty];
%     if isfield(handles.input,'output')
%         output = num2cell(handles.input.output);
%         output = [{'Output'};output];
%         array = [array output];
%     end
%     clusters = num2cell(clusters);
%     clusters = [{'Cluster'};clusters];
%     array = [array clusters];
end

% Write to file
xlswrite(str1, array, str2, str3);

handles.output = 1;
guidata(hObject, handles);
uiresume(handles.figure1);


%% --- Creates and returns a handle to the GUI figure. 
function h1 = SaveXls_LayoutFcn(policy)
% policy - create a new figure or use a singleton. 'new' or 'reuse'.

persistent hsingleton;
if strcmpi(policy, 'reuse') & ishandle(hsingleton)
    h1 = hsingleton;
    return;
end

appdata = [];
appdata.GUIDEOptions = struct(...
    'active_h', [], ...
    'taginfo', struct(...
    'figure', 2, ...
    'pushbutton', 5, ...
    'edit', 4, ...
    'text', 4), ...
    'override', 0, ...
    'release', 13, ...
    'resize', 'none', ...
    'accessibility', 'callback', ...
    'mfile', 1, ...
    'callbacks', 1, ...
    'singleton', 1, ...
    'syscolorfig', 1, ...
    'blocking', 0, ...
    'lastSavedFile', 'F:\Documents and Settings\Administrator\Desktop\Projecto CLASSE\GUI\SaveXls.m');
appdata.lastValidTag = 'figure1';
appdata.GUIDELayoutEditor = [];

h1 = figure(...
'Units','characters',...
'PaperUnits',get(0,'defaultfigurePaperUnits'),...
'CloseRequestFcn','SaveXls(''figure1_CloseRequestFcn'',gcbf,[],guidata(gcbf))',...
'Color',[0.925490196078431 0.913725490196078 0.847058823529412],...
'Colormap',[0 0 0.5625;0 0 0.625;0 0 0.6875;0 0 0.75;0 0 0.8125;0 0 0.875;0 0 0.9375;0 0 1;0 0.0625 1;0 0.125 1;0 0.1875 1;0 0.25 1;0 0.3125 1;0 0.375 1;0 0.4375 1;0 0.5 1;0 0.5625 1;0 0.625 1;0 0.6875 1;0 0.75 1;0 0.8125 1;0 0.875 1;0 0.9375 1;0 1 1;0.0625 1 1;0.125 1 0.9375;0.1875 1 0.875;0.25 1 0.8125;0.3125 1 0.75;0.375 1 0.6875;0.4375 1 0.625;0.5 1 0.5625;0.5625 1 0.5;0.625 1 0.4375;0.6875 1 0.375;0.75 1 0.3125;0.8125 1 0.25;0.875 1 0.1875;0.9375 1 0.125;1 1 0.0625;1 1 0;1 0.9375 0;1 0.875 0;1 0.8125 0;1 0.75 0;1 0.6875 0;1 0.625 0;1 0.5625 0;1 0.5 0;1 0.4375 0;1 0.375 0;1 0.3125 0;1 0.25 0;1 0.1875 0;1 0.125 0;1 0.0625 0;1 0 0;0.9375 0 0;0.875 0 0;0.8125 0 0;0.75 0 0;0.6875 0 0;0.625 0 0;0.5625 0 0],...
'IntegerHandle','off',...
'InvertHardcopy',get(0,'defaultfigureInvertHardcopy'),...
'MenuBar','none',...
'Name','Save Results to Excel file',...
'NumberTitle','off',...
'PaperPosition',get(0,'defaultfigurePaperPosition'),...
'PaperSize',[20.98404194812 29.67743169791],...
'PaperType',get(0,'defaultfigurePaperType'),...
'Position',[103.8 49.0769230769231 71.2 12.3846153846154],...
'Resize','off',...
'HandleVisibility','callback',...
'Tag','figure1',...
'UserData',[],...
'Visible','on',...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'dest';

h2 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'BackgroundColor',[1 1 1],...
'Callback','SaveXls(''dest_Callback'',gcbo,[],guidata(gcbo))',...
'HorizontalAlignment','left',...
'Position',[4.4 8.07692307692308 45.6 1.69230769230769],...
'String','',...
'Style','edit',...
'CreateFcn', {@local_CreateFcn, 'SaveXls(''dest_CreateFcn'',gcbo,[],guidata(gcbo))', appdata} ,...
'Tag','dest');

appdata = [];
appdata.lastValidTag = 'browse';

h3 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback','SaveXls(''browse_Callback'',gcbo,[],guidata(gcbo))',...
'Position',[53.4 8.07692307692308 13.8 1.76923076923077],...
'String','Browse',...
'Tag','browse',...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'text1';

h4 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'HorizontalAlignment','left',...
'Position',[4.6 9.92307692307692 11 1.15384615384615],...
'String','Destination',...
'Style','text',...
'Tag','text1',...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'text2';

h5 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Enable','off',...
'HorizontalAlignment','left',...
'Position',[4.2 5.53846153846154 12.4 1.15384615384615],...
'String','Sheet Name',...
'Style','text',...
'Tag','text2',...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'sheet';

h6 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'BackgroundColor',[1 1 1],...
'Callback','SaveXls(''sheet_Callback'',gcbo,[],guidata(gcbo))',...
'Enable','off',...
'HorizontalAlignment','left',...
'Position',[19.8 5.46153846153846 30.2 1.61538461538462],...
'String','Folha1',...
'Style','edit',...
'CreateFcn', {@local_CreateFcn, 'SaveXls(''sheet_CreateFcn'',gcbo,[],guidata(gcbo))', appdata} ,...
'Tag','sheet');

appdata = [];
appdata.lastValidTag = 'text3';

h7 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Enable','off',...
'HorizontalAlignment','left',...
'Position',[4.2 2.07692307692308 11.8 1.15384615384615],...
'String','Starting Cell',...
'Style','text',...
'Tag','text3',...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'cell';

h8 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'BackgroundColor',[1 1 1],...
'Callback','SaveXls(''cell_Callback'',gcbo,[],guidata(gcbo))',...
'Enable','off',...
'HorizontalAlignment','left',...
'Position',[19.8 2 10.2 1.61538461538462],...
'String','A1',...
'Style','edit',...
'CreateFcn', {@local_CreateFcn, 'SaveXls(''cell_CreateFcn'',gcbo,[],guidata(gcbo))', appdata} ,...
'Tag','cell');

appdata = [];
appdata.lastValidTag = 'save';

h9 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback','SaveXls(''save_Callback'',gcbo,[],guidata(gcbo))',...
'Enable','off',...
'Position',[53.4 2 13.8 2.76923076923077],...
'String','Save',...
'Tag','save',...
'CreateFcn', {@local_CreateFcn, '', appdata} );


hsingleton = h1;


% --- Set application data first then calling the CreateFcn. 
function local_CreateFcn(hObject, eventdata, createfcn, appdata)

if ~isempty(appdata)
   names = fieldnames(appdata);
   for i=1:length(names)
       name = char(names(i));
       setappdata(hObject, name, getfield(appdata,name));
   end
end

if ~isempty(createfcn)
   eval(createfcn);
end


% --- Handles default GUIDE GUI creation and callback dispatch
function varargout = gui_mainfcn(gui_State, varargin)


%   GUI_MAINFCN provides these command line APIs for dealing with GUIs
%
%      SaveXls, by itself, creates a new SaveXls or raises the existing
%      singleton*.
%
%      H = SaveXls returns the handle to a new SaveXls or the handle to
%      the existing singleton*.
%
%      SaveXls('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SaveXls.M with the given input arguments.
%
%      SaveXls('Property','Value',...) creates a new SaveXls or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before untitled_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to untitled_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".

%   Copyright 1984-2005 The MathWorks, Inc.
%   $Revision: 1.4.6.14 $ $Date: 2005/12/15 20:58:44 $

gui_StateFields =  {'gui_Name'
    'gui_Singleton'
    'gui_OpeningFcn'
    'gui_OutputFcn'
    'gui_LayoutFcn'
    'gui_Callback'};
gui_Mfile = '';
for i=1:length(gui_StateFields)
    if ~isfield(gui_State, gui_StateFields{i})
        error('MATLAB:gui_mainfcn:FieldNotFound', 'Could not find field %s in the gui_State struct in GUI M-file %s', gui_StateFields{i}, gui_Mfile);
    elseif isequal(gui_StateFields{i}, 'gui_Name')
        gui_Mfile = [gui_State.(gui_StateFields{i}), '.m'];
    end
end

numargin = length(varargin);

if numargin == 0
    % SaveXls
    % create the GUI
    gui_Create = 1;
elseif local_isInvokeActiveXCallback(gui_State, varargin{:})
    % SaveXls(ACTIVEX,...)
    vin{1} = gui_State.gui_Name;
    vin{2} = [get(varargin{1}.Peer, 'Tag'), '_', varargin{end}];
    vin{3} = varargin{1};
    vin{4} = varargin{end-1};
    vin{5} = guidata(varargin{1}.Peer);
    feval(vin{:});
    return;
elseif local_isInvokeHGCallbak(gui_State, varargin{:})
    % SaveXls('CALLBACK',hObject,eventData,handles,...)
    gui_Create = 0;
else
    % SaveXls(...)
    % create the GUI and hand varargin to the openingfcn
    gui_Create = 1;
end

if gui_Create == 0
    varargin{1} = gui_State.gui_Callback;
    if nargout
        [varargout{1:nargout}] = feval(varargin{:});
    else
        feval(varargin{:});
    end
else
    if gui_State.gui_Singleton
        gui_SingletonOpt = 'reuse';
    else
        gui_SingletonOpt = 'new';
    end

    % Open fig file with stored settings.  Note: This executes all component
    % specific CreateFunctions with an empty HANDLES structure.

    % Do feval on layout code in m-file if it exists
    if ~isempty(gui_State.gui_LayoutFcn)
        gui_hFigure = feval(gui_State.gui_LayoutFcn, gui_SingletonOpt);
        % openfig (called by local_openfig below) does this for guis without
        % the LayoutFcn. Be sure to do it here so guis show up on screen.
        movegui(gui_hFigure,'onscreen')
    else
        gui_hFigure = local_openfig(gui_State.gui_Name, gui_SingletonOpt);
        % If the figure has InGUIInitialization it was not completely created
        % on the last pass.  Delete this handle and try again.
        if isappdata(gui_hFigure, 'InGUIInitialization')
            delete(gui_hFigure);
            gui_hFigure = local_openfig(gui_State.gui_Name, gui_SingletonOpt);
        end
    end

    % Set flag to indicate starting GUI initialization
    setappdata(gui_hFigure,'InGUIInitialization',1);

    % Fetch GUIDE Application options
    gui_Options = getappdata(gui_hFigure,'GUIDEOptions');

    if ~isappdata(gui_hFigure,'GUIOnScreen')
        % Adjust background color
        if gui_Options.syscolorfig
            set(gui_hFigure,'Color', get(0,'DefaultUicontrolBackgroundColor'));
        end

        % Generate HANDLES structure and store with GUIDATA. If there is
        % user set GUI data already, keep that also.
        data = guidata(gui_hFigure);
        handles = guihandles(gui_hFigure);
        if ~isempty(handles)
            if isempty(data)
                data = handles;
            else
                names = fieldnames(handles);
                for k=1:length(names)
                    data.(char(names(k)))=handles.(char(names(k)));
                end
            end
        end
        guidata(gui_hFigure, data);
    end

    % If user specified 'Visible','off' in p/v pairs, don't make the figure
    % visible.
    gui_MakeVisible = 1;
    for ind=1:2:length(varargin)
        if length(varargin) == ind
            break;
        end
        len1 = min(length('visible'),length(varargin{ind}));
        len2 = min(length('off'),length(varargin{ind+1}));
        if ischar(varargin{ind}) && ischar(varargin{ind+1}) && ...
                strncmpi(varargin{ind},'visible',len1) && len2 > 1
            if strncmpi(varargin{ind+1},'off',len2)
                gui_MakeVisible = 0;
            elseif strncmpi(varargin{ind+1},'on',len2)
                gui_MakeVisible = 1;
            end
        end
    end

    % Check for figure param value pairs
    for index=1:2:length(varargin)
        if length(varargin) == index || ~ischar(varargin{index})
            break;
        end
        try set(gui_hFigure, varargin{index}, varargin{index+1}), catch break, end
    end

    % If handle visibility is set to 'callback', turn it on until finished
    % with OpeningFcn
    gui_HandleVisibility = get(gui_hFigure,'HandleVisibility');
    if strcmp(gui_HandleVisibility, 'callback')
        set(gui_hFigure,'HandleVisibility', 'on');
    end

    feval(gui_State.gui_OpeningFcn, gui_hFigure, [], guidata(gui_hFigure), varargin{:});

    if isscalar(gui_hFigure) && ishandle(gui_hFigure)
        % Update handle visibility
        set(gui_hFigure,'HandleVisibility', gui_HandleVisibility);

        % Make figure visible
        if gui_MakeVisible
            set(gui_hFigure, 'Visible', 'on')
            if gui_Options.singleton
                setappdata(gui_hFigure,'GUIOnScreen', 1);
            end
        end

        % Done with GUI initialization
        rmappdata(gui_hFigure,'InGUIInitialization');
    end

    % If handle visibility is set to 'callback', turn it on until finished with
    % OutputFcn
    if isscalar(gui_hFigure) && ishandle(gui_hFigure)
        gui_HandleVisibility = get(gui_hFigure,'HandleVisibility');
        if strcmp(gui_HandleVisibility, 'callback')
            set(gui_hFigure,'HandleVisibility', 'on');
        end
        gui_Handles = guidata(gui_hFigure);
    else
        gui_Handles = [];
    end

    if nargout
        [varargout{1:nargout}] = feval(gui_State.gui_OutputFcn, gui_hFigure, [], gui_Handles);
    else
        feval(gui_State.gui_OutputFcn, gui_hFigure, [], gui_Handles);
    end

    if isscalar(gui_hFigure) && ishandle(gui_hFigure)
        set(gui_hFigure,'HandleVisibility', gui_HandleVisibility);
    end
end

function gui_hFigure = local_openfig(name, singleton)

% this application data is used to indicate the running mode of a GUIDE
% GUI to distinguish it from the design mode of the GUI in GUIDE.
setappdata(0,'OpenGuiWhenRunning',1);

% openfig with three arguments was new from R13. Try to call that first, if
% failed, try the old openfig.
try
    gui_hFigure = openfig(name, singleton, 'auto');
catch
    % OPENFIG did not accept 3rd input argument until R13,
    % toggle default figure visible to prevent the figure
    % from showing up too soon.
    gui_OldDefaultVisible = get(0,'defaultFigureVisible');
    set(0,'defaultFigureVisible','off');
    gui_hFigure = openfig(name, singleton);
    set(0,'defaultFigureVisible',gui_OldDefaultVisible);
end
rmappdata(0,'OpenGuiWhenRunning');

function result = local_isInvokeActiveXCallback(gui_State, varargin)

try
    result = ispc && iscom(varargin{1}) ...
             && isequal(varargin{1},gcbo);
catch
    result = false;
end

function result = local_isInvokeHGCallbak(gui_State, varargin)

try
    fhandle = functions(gui_State.gui_Callback);
    result = ~isempty(findstr(gui_State.gui_Name,fhandle.file)) ...
             && ischar(varargin{1}) ...
             && isequal(ishandle(varargin{2}), 1);
catch
    result = false;
end

