function varargout = SomClusteringGUI(varargin)
% SOMCLUSTERINGGUI M-file for SomClusteringGUI.fig
%      SOMCLUSTERINGGUI, by itself, creates a new SOMCLUSTERINGGUI or raises the existing
%      singleton*.
%
%      H = SOMCLUSTERINGGUI returns the handle to a new SOMCLUSTERINGGUI or the handle to
%      the existing singleton*.
%
%      SOMCLUSTERINGGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SOMCLUSTERINGGUI.M with the given input arguments.
%
%      SOMCLUSTERINGGUI('Property','Value',...) creates a new SOMCLUSTERINGGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before SomClusteringGUI_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to SomClusteringGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES
%
% CLASSE Project
% Created by Edgar Ferreira - FCTUC
% edgars@student.dei.uc.pt / edgar.bajouca@gmail.com
% Updated June 15, 2007
%
% Copyright (C) 2007 Edgar Ferreira  FCTUC Coimbra, Portugal
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.

% Edit the above text to modify the response to help SomClusteringGUI

% Last Modified by GUIDE v2.5 13-Jul-2007 17:47:10

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @SomClusteringGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @SomClusteringGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


%% --- Executes just before SomClusteringGUI is made visible.
function SomClusteringGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to SomClusteringGUI (see VARARGIN)

% Get input variables and structures
in_vars = varargin;
input = in_vars{1};
if isfield(input,'rawData')
    handles.rawData = input.rawData;
end
handles.labels = input.labels;
handles.type = input.som_data;

% Get input parameters for reduced data
if handles.type==1
    handles.reducedData = input.reducedData;
    handles.data=input.somData;        %reduced matrix
    text='reduced matrix.';

    % Display Info
    set(handles.info,'String',strvcat('INPUT DATA INFO:',char(handles.reducedData.textToLog), ' ','SOM CLUSTERING INFO:'));

% Get input parameters for original data
else
    handles.data=handles.rawData.original;   % original matrix
    text='original data.';
    
    % Display Info
    set(handles.info,'String','SOM CLUSTERING INFO:');
end

handles.sD=som_data_struct(handles.data);   % create data structure
sTo=som_topol_struct(handles.sD);           % create topology structure (only to get parameters: msize)

% write information
set(handles.map_sz,'String',['[' num2str(sTo.msize) ']']);
str=get(handles.info,'String');
set(handles.info,'String',strvcat(str,['Created Data Structure from ' text]));

% Choose default command line output for SomClusteringGUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes SomClusteringGUI wait for user response (see UIRESUME)
%uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = SomClusteringGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);

%% SOM INITIALIZATION PANEL
%% SOM Initialization Parameters
% --- Executes on button press in norm.
function norm_Callback(hObject, eventdata, handles)
% hObject    handle to norm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if (get(handles.norm,'Value') == get(handles.norm,'Max'))   %if selected
    set(handles.norm_opt,'Enable','on');
    % On each callback, map size must be updated
    str=get(handles.norm_opt,'String');
    val=get(handles.norm_opt,'Value');
    method=lower(str{val});
    sD_temp=som_normalize(handles.sD,method);   % temporary sD predicting selected normalization
    sTo=som_topol_struct(sD_temp);              % create topology structure (only to get parameters: msize)
    set(handles.map_sz,'String',['[' num2str(sTo.msize) ']']);  %update msize
else                                                        %if not selected
    set(handles.norm_opt,'Enable','off');
    % On each callback, map size must be updated (to the original)
    sTo=som_topol_struct(handles.sD);              % create topology structure (only to get parameters: msize)
    set(handles.map_sz,'String',['[' num2str(sTo.msize) ']']);  %update msize
end

% --- Executes on selection change in norm_opt.
function norm_opt_Callback(hObject, eventdata, handles)
% hObject    handle to norm_opt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% On each callback, map size must be updated
str=get(handles.norm_opt,'String');
val=get(handles.norm_opt,'Value');
method=lower(str{val});
sD_temp=som_normalize(handles.sD,method);   % temporary sD predicting selected normalization
sTo=som_topol_struct(sD_temp);              % create topology structure (only to get parameters: msize)
set(handles.map_sz,'String',['[' num2str(sTo.msize) ']']);  %update msize

set(handles.train,'enable','on');

% --- Executes during object creation, after setting all properties.
function norm_opt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to norm_opt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function map_sz_CreateFcn(hObject, eventdata, handles)
% hObject    handle to map_sz (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in lat.
function lat_Callback(hObject, eventdata, handles)
% hObject    handle to lat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns lat contents as cell array
%        contents{get(hObject,'Value')} returns selected item from lat
set(handles.train,'enable','on');

% --- Executes during object creation, after setting all properties.
function lat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% --- Executes on button press in train.
function train_Callback(hObject, eventdata, handles)
% hObject    handle to train (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(hObject,'Enable','Off')
pause(0.001);
% Get parameters
msize=str2num(get(handles.map_sz,'String'));
str=get(handles.lat,'String');
val=get(handles.lat,'Value');
lat=lower(str{val});

% Validate parameters
if isempty(msize) || length(msize)~=2
    errordlg('Map size must be a 2 integers vector','Invalid Parameter','modal')
else
    % Normalization if selected
    if (get(handles.norm,'Value') == 1)
        str=get(handles.norm_opt,'String');
        val=get(handles.norm_opt,'Value');
        method=lower(str{val});

        handles.sD.data=handles.data;   % recover original data before normalization
        handles.sD=som_normalize(handles.sD,method);

        str=get(handles.info,'String');
        set(handles.info,'String',strvcat(str,['Data Structure normalized.']));
    end

    % Training SOM
    handles.sM=som_make(handles.sD,'msize',round(abs(msize)),lat);  %create and train SOM Map

    % Visualization of SOM
    if (get(handles.basic,'Value') == 1)    %if basic visualization is selected
        figure('name','new')
        title('Basic Visualization of SOM')
        som_show(handles.sM)
    end
    if (get(handles.adv,'Value') == 1)      %if advanced visualization is selected
        figure('name','Advanced Visualizations of SOM')

        subplot(2,2,1)      %Distance Matrix
        C=som_colorcode(handles.sM);
        U = som_umat(handles.sM);
        Um = U(1:2:size(U,1),1:2:size(U,2));
        som_cplane(handles.sM,C,1-Um(:)/max(Um(:)));
        title('Color Coding + Distance Matrix')

        subplot(2,2,2)      %Surface Distance Matrix
        Co=som_unit_coords(handles.sM); U=som_umat(handles.sM); U=U(1:2:size(U,1),1:2:size(U,2));
        som_grid(handles.sM,'Coord',[Co, U(:)],'Surf',U(:),'Marker','none');
        view(-80,45), axis tight, title('Distance Matrix')

        subplot(2,2,3)      %Codebook positions
        if size(handles.data,2)==2
            som_grid(handles.sM,'Coord',handles.sM.codebook(:,1:2))
        elseif size(handles.data,2)==3
            som_grid(handles.sM,'Coord',handles.sM.codebook(:,1:3))
            view(-80,45)
        else
            proj=pcaproj(handles.sM.codebook,3);
            som_grid(handles.sM,'Coord',proj(:,1:3))
            view(-80,45)
        end
        axis tight, title('Prototypes')

        subplot(2,2,4)      %Data and codebook positions
        if size(handles.data,2)==2
            plot(handles.sD.data(:,1),handles.sD.data(:,2),'x')
            hold on
            som_grid(handles.sM,'Coord',handles.sM.codebook(:,1:2))
        elseif size(handles.data,2)==3
            plot3(handles.sD.data(:,1),handles.sD.data(:,2),handles.sD.data(:,3),'x')
            hold on
            som_grid(handles.sM,'Coord',handles.sM.codebook(:,1:3))
            view(-80,45)
        else
            data_proj=pcaproj(handles.sD.data,3);
            plot3(data_proj(:,1),data_proj(:,2),data_proj(:,3),'x')
            hold on
            som_grid(handles.sM,'Coord',proj(:,1:3))
            view(-80,45)
        end

        % Activate datacursor
        mylabels(handles.sD.data,handles.labels)
        grid on
        hold off, axis tight, title('Prototypes and Data')
    end

    % Update Info
    str=get(handles.info,'String');
    set(handles.info,'String',strvcat(str,'Map Structure created.'));

    % Enable objects on first training
    if strcmpi(get(handles.clust_method,'enable'),'off')
        set([handles.cl_text handles.clust_method handles.create handles.prot],'Enable','on');
        set([handles.k_max handles.rad_def handles.rad_max],'Enable','on');
    end
    set(handles.save_menu,'Enable','off');

    guidata(hObject, handles);
end
set(hObject,'Enable','On')

% --- Executes during object creation, after setting all properties.
function info_CreateFcn(hObject, eventdata, handles)
% hObject    handle to info (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% SOM CLUSTERING PANEL
%% --- Executes on selection change in clust_method.
function clust_method_Callback(hObject, eventdata, handles)
% hObject    handle to clust_method (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns clust_method contents as cell array
%        contents{get(hObject,'Value')} returns selected item from clust_method

set(handles.create,'Enable','On')

str=get(handles.clust_method,'String');
val=get(handles.clust_method,'Value');
method=str{val};

switch method
   case 'SOM K-Means'
      if (get(handles.rad_max,'Value') == get(handles.rad_max,'Max'))
          set([handles.rad_max handles.rad_def handles.k_max],'Enable','on');
      else
          set([handles.rad_max handles.rad_def handles.k_def],'Enable','on');
      end
      set([handles.u_link handles.u_neig handles.u_text1 handles.u_text2],'Enable','off');
      set([handles.h_text1 handles.h_text2 handles.h_nr handles.h_link],'Enable','off');
      set([handles.s_text1 handles.s_text2 handles.s_text3 handles.range handles.accept handles.reject],'Enable','off');
      set([handles.create handles.prot],'Enable','on');
   case 'SOM U-Matrix'
      set([handles.rad_max handles.rad_def handles.k_max handles.k_def],'Enable','off');
      set([handles.u_link handles.u_neig handles.u_text1 handles.u_text2],'Enable','on');
      set([handles.h_text1 handles.h_text2 handles.h_nr handles.h_link],'Enable','off');
      set([handles.s_text1 handles.s_text2 handles.s_text3 handles.range handles.accept handles.reject],'Enable','off');
      set([handles.create handles.prot],'Enable','on');
   case 'Hierarchical'
      set([handles.rad_max handles.rad_def handles.k_max handles.k_def],'Enable','off');
      set([handles.u_link handles.u_neig handles.u_text1 handles.u_text2],'Enable','off');
      set([handles.h_text1 handles.h_text2 handles.h_nr handles.h_link],'Enable','on');
      set([handles.s_text1 handles.s_text2 handles.s_text3 handles.range handles.accept handles.reject],'Enable','off');
      set([handles.create handles.prot],'Enable','on');
   case 'Fuzzy Subtractive'
      set([handles.rad_max handles.rad_def handles.k_max handles.k_def],'Enable','off');
      set([handles.u_link handles.u_neig handles.u_text1 handles.u_text2],'Enable','off');
      set([handles.h_text1 handles.h_text2 handles.h_nr handles.h_link],'Enable','off');
      set([handles.s_text1 handles.s_text2 handles.s_text3 handles.range handles.accept handles.reject],'Enable','on');
      set([handles.create handles.prot],'Enable','on'); 
   otherwise
      %nothing
end

% --- Executes during object creation, after setting all properties.
function clust_method_CreateFcn(hObject, eventdata, handles)
% hObject    handle to clust_method (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Parameters in K-Means Panel
% --- Executes on button press in rad_max.
function rad_max_Callback(hObject, eventdata, handles)
% hObject    handle to rad_max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of rad_max
set(handles.rad_max,'Value',1.0);
set(handles.rad_def,'Value',0.0);
set(handles.k_max,'Enable','on');
set(handles.k_def,'Enable','off');

% --- Executes during object creation, after setting all properties.
function k_max_CreateFcn(hObject, eventdata, handles)
% hObject    handle to k_max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in rad_def.
function rad_def_Callback(hObject, eventdata, handles)
% hObject    handle to rad_def (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of rad_def
set(handles.rad_max,'Value',0.0);
set(handles.rad_def,'Value',1.0);
set(handles.k_max,'Enable','off');
set(handles.k_def,'Enable','on');

% --- Executes during object creation, after setting all properties.
function k_def_CreateFcn(hObject, eventdata, handles)
% hObject    handle to k_def (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Parameters in U-Matrix Panel
% --- Executes during object creation, after setting all properties.
function u_link_CreateFcn(hObject, eventdata, handles)
% hObject    handle to u_link (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function u_neig_CreateFcn(hObject, eventdata, handles)
% hObject    handle to u_neig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Parameters in Hierarchical Panel
% --- Executes during object creation, after setting all properties.
function h_nr_CreateFcn(hObject, eventdata, handles)
% hObject    handle to h_nr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function h_link_CreateFcn(hObject, eventdata, handles)
% hObject    handle to h_link (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Parameters in Subtractive Panel
% --- Executes during object creation, after setting all properties.
function range_CreateFcn(hObject, eventdata, handles)
% hObject    handle to range (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function accept_CreateFcn(hObject, eventdata, handles)
% hObject    handle to accept (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function reject_CreateFcn(hObject, eventdata, handles)
% hObject    handle to reject (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% --- Executes on button press in create.
function create_Callback(hObject, eventdata, handles)
% hObject    handle to create (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(hObject,'Enable','Off')
pause(0.001);

str=get(handles.clust_method,'String');
val=get(handles.clust_method,'Value');
method=str{val};

% prototypes selected or not
prot=get(handles.prot,'Value');

switch method       % check wich clustering method is selected
    case 'SOM K-Means'
        if (get(handles.rad_max,'Value') == get(handles.rad_max,'Max'))
            % maximum nr of clusters defined
            str1 = get(handles.k_max,'String');
            if sum(isstrprop(str1, 'digit'))~=size(str1,2) | str2double(str1) > 30     %check validity of number
                errordlg('Maximum number of clusters is 30','Incorrect Selection','modal')
            else
                % create and plot clusters
                handles.maxi=str2double(str1);
                clusters=SomClustering('k-means',handles.sD.data,handles.sM,handles.maxi,0,prot);
                str=get(handles.info,'String');
                set(handles.info,'String',strvcat(str,'K-Means Clustering done.', ['Lower Davies-Bouldin index: ' num2str(max(clusters)) ' Clusters.']));
                parameters.criterium = 'Lower Davies-Bouldin index';
            end
        else
            % exact nr of clusters defined
            str1 = get(handles.k_def,'String');
            if sum(isstrprop(str1, 'digit'))~=size(str1,2) | str2double(str1) > 30     %check validity of number
                errordlg('Maximum number of clusters is 30','Incorrect Selection','modal')
            else
                % create and plot clusters
                handles.nr=str2double(str1);
                clusters=SomClustering('k-means',handles.sD.data,handles.sM,0,handles.nr,prot);
                str=get(handles.info,'String');
                set(handles.info,'String',strvcat(str,'K-Means Clustering done.'));
                parameters.criterium = 'Defined number of clusters';
            end
        end

    case 'SOM U-Matrix'
        % get parameters
        str1 = get(handles.u_neig,'String');    %neighbors
        str2=get(handles.u_link,'String');
        val2=get(handles.u_link,'Value');
        link=lower(str2{val2});                 %linkage

        if sum(isstrprop(str1, 'digit'))~=size(str1,2) | str2double(str1) > (min(handles.sM.topol.msize))     %check validity of neighbors
            errordlg(['Maximum number of neighbors is minimum Map Size: ' num2str(min(handles.sM.topol.msize))],'Incorrect Selection','modal')
        else
            % create and plot clusters
            clusters=SomClustering('u-matrix',handles.sD.data,handles.sM,link,str1,prot);
            str=get(handles.info,'String');
            set(handles.info,'String',strvcat(str,['U-Matrix Clustering done. ' num2str(max(clusters)) ' clusters created.']));
            parameters.neighbors = str2double(str1);
            parameters.linkage = link;
        end

    case 'Hierarchical'
        % get parameters
        str1 = get(handles.h_nr,'String');      %clusters
        str2=get(handles.h_link,'String');
        val2=get(handles.h_link,'Value');
        link=str2{val2};                 %linkage

        if sum(isstrprop(str1, 'digit'))~=size(str1,2)     %check validity of number
            errordlg('Number of Clusters must be an integer','Incorrect Selection','modal')
        else
            % create and plot clusters
            clusters=SomClustering('hierar',handles.sD.data,handles.sM,str2double(str1),link,prot);
            str=get(handles.info,'String');
            set(handles.info,'String',strvcat(str,'Hierarchical Clustering done.'));
            parameters.metric = 'Euclidean';
            parameters.linkage = link;
        end

    case 'Fuzzy Subtractive'
        % get parameters
        rg=str2double(get(handles.range,'String'));   %convert range to double
        ac=str2double(get(handles.accept,'String'));   %convert accept to double
        rj=str2double(get(handles.reject,'String'));   %convert reject to double

        % create and plot clusters
        clusters=SomClustering('subt',handles.sD.data,handles.sM,rg,[ac rj],prot);
        str=get(handles.info,'String');
        set(handles.info,'String',strvcat(str,['Subtractive Clustering done. ' num2str(max(clusters)) ' clusters created.']));
        parameters.range = rg;
        parameters.quash = 1.25;
        parameters.accept = ac;
        parameters.reject = rj;
    otherwise
        %nothing
end

% Delete clusteringData structure
if isfield(handles,'clusteringData')
    handles = rmfield(handles,'clusteringData');
end

% Update structure
handles.clusteringData.type = 'som';
handles.clusteringData.method = method;
handles.clusteringData.clusters = clusters;
handles.clusteringData.parameters = parameters;
handles.clusteringData.parameters.nrClusters = max(clusters);
handles.clusteringData.parameters.dimension = size(handles.sD.data,2);
handles.clusteringData.sD = handles.sD;
handles.clusteringData.sM = handles.sM;

set(handles.save_menu,'Enable','on');
guidata(hObject, handles);

mylabels(handles.sD.data,handles.labels)
grid on
set(hObject,'Enable','On')
%-------------------------------------------------------------------------

%% MENU FUNCTIONS
% --------------------------------------------------------------------
function load_menu_Callback(hObject, eventdata, handles)
% hObject    handle to load_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function load_sd_Callback(hObject, eventdata, handles)
% hObject    handle to load_sd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[filename, pathname] = uigetfile({'*.mat', 'MAT-Files (*.mat)';'*.*','All Files (*.*)'},'Select a SOM Data Structure to load');

% If "Cancel" is selected then return
if isequal([filename,pathname],[0,0])
    return
% Otherwise construct the fullfilename and load the selected array in MAT-File
else
    File = fullfile(pathname,filename);
    handles.filename=filename;   %neaded to write in info box
    struc=open(File);
    names = fieldnames(struc);  %get list off arrays in mat-file
    found=0;    %found nothing
    aux=find(strcmp(names,'clusteringData'));
    if aux>0
        clusteringData = struc.(names{aux});
        if isfield(clusteringData,'sD')
            found=1;    %found sD
            handles.sD=clusteringData.sD;
        end
    end
    if found==1
        % Load structures
        aux=find(strcmp(names,'rawData'));
        if aux>0
            handles.rawData = struc.(names{aux});
        end
        aux=find(strcmp(names,'labels'));
        if aux>0
            handles.rawData = struc.(names{aux});
        end
        aux=find(strcmp(names,'reducedData'));
        if aux>0
            handles.type = 1;
            handles.reducedData = struc.(names{aux});
        else
            handles.type = 2;   %no data from dimension reduction
        end
        
        % Disable objects for clustering
        set([handles.rad_max handles.rad_def handles.k_max handles.k_def],'Enable','off');
        set([handles.u_link handles.u_neig handles.u_text1 handles.u_text2],'Enable','off');
        set([handles.h_text1 handles.h_text2 handles.h_nr handles.h_link],'Enable','off');
        set([handles.s_text1 handles.s_text2 handles.s_text3 handles.range handles.accept handles.reject],'Enable','off');
        set([handles.create handles.prot handles.clust_method handles.cl_text],'Enable','off');
        set(handles.save_menu,'Enable','off');
        set(handles.rad_max,'Value',1);set(handles.rad_def,'Value',0);
        
        % Enable objects for training
        set([handles.norm handles.map_sz handles.lat handles.basic handles.adv handles.train handles.text1 handles.text2 handles.text3],'Enable','on');
        
        % Update and display new info
        sTo=som_topol_struct(handles.sD);           % create topology structure (only to get parameters in the future)
        set(handles.map_sz,'String',['[' num2str(sTo.msize) ']']);
        str=get(handles.info,'String');
        set(handles.info,'String',strvcat(str,['Data Structure loaded from file.']));
        
        % Save handles
        guidata(hObject, handles); 
    else
        errordlg('File doesn`t contain a valid SOM Data Structure','Incorrect Selection','modal')
    end
end

% --------------------------------------------------------------------
function load_sm_Callback(hObject, eventdata, handles)
% hObject    handle to load_sm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[filename, pathname] = uigetfile({'*.mat', 'MAT-Files (*.mat)';'*.*','All Files (*.*)'},'Select a SOM Structure to Load');

% If "Cancel" is selected then return
if isequal([filename,pathname],[0,0])
    return
% Otherwise construct the fullfilename and load the selected array in MAT-File
else
    File = fullfile(pathname,filename);
    handles.filename=filename;   %neaded to write in info box
    struc=open(File);
    names = fieldnames(struc);  %get list off arrays in mat-file
    found=0;    %found nothing
    aux=find(strcmp(names,'clusteringData'));
    if aux>0
        clusteringData = struc.(names{aux});
        if isfield(clusteringData,'sM')
            found=1;    %found sM
            handles.sM=clusteringData.sM;
            handles.sD=clusteringData.sD;
        end
    end
    if found==1
        % Load structures
        aux=find(strcmp(names,'rawData'));
        if aux>0
            handles.rawData = struc.(names{aux});
        end
        aux=find(strcmp(names,'labels'));
        if aux>0
            handles.rawData = struc.(names{aux});
        end
        aux=find(strcmp(names,'reducedData'));
        if aux>0
            handles.type = 1;
            handles.reducedData = struc.(names{aux});
        else
            handles.type = 2;   %no data from dimension reduction
        end
        
        % Enable objects
        if strcmpi(get(handles.clust_method,'enable'),'off')
            set([handles.cl_text handles.clust_method handles.create handles.prot],'Enable','on');
            set([handles.k_max handles.rad_def handles.rad_max],'Enable','on');
        end
        
        set(handles.rad_max,'Value',1);set(handles.rad_def,'Value',0);
        
        % Disable objects for training and save
        set([handles.norm handles.norm_opt handles.map_sz handles.lat handles.basic handles.adv handles.train handles.text1 handles.text2 handles.text3],'Enable','off');
        set(handles.save_menu,'Enable','off');
        
        % Update and display new info
        str=get(handles.info,'String');
        set(handles.info,'String',strvcat(str,['Map Structure loaded from file.']));
        
        % Save handles
        guidata(hObject, handles); 
    else
        errordlg('File doesn`t contain a valid SOM Map Structure','Incorrect Selection','modal')
    end
end

% --------------------------------------------------------------------
function save_menu_Callback(hObject, eventdata, handles)
% hObject    handle to save_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function save_xls_Callback(hObject, eventdata, handles)
% hObject    handle to save_xls (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Variables to send to Save GUI
if handles.type == 1
    if size(handles.sD.data,2)==3
        send.header = {'1st Dimension' '2nd Dimension' '3rd Dimension'};
    else
        send.header = {'1st Dimension' '2nd Dimension'};
    end
else
    send.header = handles.labels.varNames;
end
send.labels = handles.labels;
send.data = handles.sD.data;
send.clusters = handles.clusteringData.clusters;
send.text = [handles.clusteringData.method ' Clustering'];

input=SaveXls(send);   % run Save GUI

if input==1
    str=get(handles.info,'String');
    set(handles.info,'String',strvcat(str,'Results saved to Excel File.'));
end

% --------------------------------------------------------------------
function save_mat_Callback(hObject, eventdata, handles)
% hObject    handle to save_mat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Save dialog
[a,b]=uiputfile('*.mat','Save Data Matrix and Clustering Results');

if isequal([a,b],[0,0])
    return
else
    c=strcat(b,a);

    % Get structures to save
    if isfield(handles,'rawData')
        rawData = handles.rawData;
    end
    labels = handles.labels;
    if handles.type == 1
        reducedData = handles.reducedData;
    end
    clusteringData = handles.clusteringData;

    % Save all structures:
    if handles.type == 1
        if isfield(handles,'rawData')
            save (c,'rawData','labels','reducedData','clusteringData')
        else
            save (c,'labels','reducedData','clusteringData')
        end
    else
        if isfield(handles,'rawData')
            save (c,'rawData','labels','clusteringData')
        else
            save (c,'labels','clusteringData')
        end
    end

    % Update Info
    str=get(handles.info,'String');
    set(handles.info,'String',strvcat(str,['Results saved do MAT-File: ' a]));
end

% --------------------------------------------------------------------
function save_work_Callback(hObject, eventdata, handles)
% hObject    handle to save_work (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Save all structures:
if isfield(handles,'rawData')
    assignin('base','rawData', handles.rawData);
end
assignin('base','labels', handles.labels);
if handles.type == 1
    assignin('base','reducedData', handles.reducedData);
end
assignin('base','clusteringData', handles.clusteringData);

% Update Info
str=get(handles.info,'String');
set(handles.info,'String',strvcat(str,'Results sent to Workspace.'));

%% SUB-FUNCTIONS AREA
% --- Functions to set datacursor information
function mylabels(data,labels)
% format data for 2D or 3D
if size(data,2)>3
    data=pcaproj(data,3);
end

% rotines to activate datacursor (saving labels and point coordinates)
dcm_obj = datacursormode;
cursor.labels=labels;
cursor.data=data;
set(dcm_obj,'DisplayStyle','datatip','SnapToDataVertex','on',...
    'Enable','on','UpdateFcn',{@myupdatefcn,cursor})


function txt = myupdatefcn(empt,event_obj,cursor)
% get labels, data coordinates and clicked coordinates
labels=cursor.labels;
data=cursor.data;
coordinates=event_obj.Position;

% check labels position for selected point
pos=0;
for i=1:size(data,1)
    if coordinates==data(i,:)
        pos=i;
        break
    end
end
%pos = get(event_obj,'DataIndex');
if pos>0
    % format text to display
    nrOfLabels = length(labels.header);
    txt=cell(1,nrOfLabels);
    for i=1: nrOfLabels
        aux = [char(labels.header(i)) ': ' char(labels.(['Label_' num2str(i)])(pos))];
        txt(i) = {aux};
    end
else
    % format coordinates to display
    txt=cell(1,size(data,2));
    coord=[{'X: '},{'Y: '},{'Z: '}];
    for i=1: size(data,2)
        aux=[char(coord(i)) num2str(coordinates(i))];
        txt(i) = {aux};
    end
end


