function varargout = nlpcaGui(varargin)
% NLPCAGUI M-file for nlpcaGui.fig
%      NLPCAGUI, by itself, creates a new NLPCAGUI or raises the existing
%      singleton*.
%
%      H = NLPCAGUI returns the handle to a new NLPCAGUI or the handle to
%      the existing singleton*.
%
%      NLPCAGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NLPCAGUI.M with the given input arguments.
%
%      NLPCAGUI('Property','Value',...) creates a new NLPCAGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before nlpcaGui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to nlpcaGui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES
%
% CLASSE Project
% Created by  Paulo Barbeiro - FCTUC
% barbeiro@student.dei.uc.pt / paulobarbeiro@gmail.com
% Updated June 15, 2007
%
% Copyright (C) 2007 Paulo Barbeiro  FCTUC Coimbra, Portugal
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.

% Edit the above text to modify the response to help nlpcaGui

% Last Modified by GUIDE v2.5 06-Jun-2008 16:37:10

% Begin initialization code - DO NOT EDIT


gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @nlpcaGui_OpeningFcn, ...
                   'gui_OutputFcn',  @nlpcaGui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before nlpcaGui is made visible.
function nlpcaGui_OpeningFcn(hObject, eventdata, handles, varargin)
    % This function has no output args, see OutputFcn.
    % hObject    handle to figure
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    % varargin   command line arguments to nlpcaGui (see VARARGIN)

    input=varargin;
    handles.reducedData.dataMatrix=input{1};
    handles.reducedData.plotHeader=input{2};
    handles.labels = input{3};

    % Choose default command line output for save_xls
    handles.output = hObject;

    % Update handles structure
    guidata(hObject, handles);

    % UIWAIT makes nlpcaGui wait for user response (see UIRESUME)
    set(handles.figure1,'WindowStyle','modal')
    uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = nlpcaGui_OutputFcn(hObject, eventdata, handles) 
    % varargout  cell array for returning output args (see VARARGOUT);
    % hObject    handle to figure
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Get default command line output from handles structure
    if exist('handles','var')
        if isfield(handles,'pointsInNewSpace')
            varargout{1} = handles.pointsInNewSpace';
            delete(handles.figure1);
        else
            varargout{1} = [];
        end
    else
        varargout{1} = [];
    end

%% Non Linear Pca
function calculateNlpcaButton_Callback(hObject, eventdata, handles)
%
% This function calculates the several nonLinear Components.
% Se calcmode file for more information how each of them is calculated
%
%
global iprint isave linear nensemble testfrac segmentlength ...
    overfit_tol earlystop_tol xscaling penalty maxiter initRand ...
    initwt_radius options  n l m nbottle iter Jscale xmean xstd...
    ntrain xtrain utrain xitrain ntest xtest utest xitest MSEx ...
    ens_accept ens_MSEx ens_W ens_utrain ens_xitrain ens_utest...
    ens_xitest

folderName = get(handles.dest_folder,'string');
LinearFileName = get(handles.linFile,'string');
NonLinearFileName = get(handles.nonLinFile,'string');

% Determines wich component is being calculated
if strcmp(get(handles.see_1st_comp,'Enable'),'off')
    CalcComp = 1;
elseif(strcmp(get(handles.see_2nd_comp,'Enable'),'off'))
    CalcComp = 2;
elseif(strcmp(get(handles.see_3rd_comp,'Enable'),'off'))
    CalcComp = 3;
end

%checks for existence of files with same names of thosw who will be
%created
filesExist=false;
calculate=true;
if CalcComp == 1;
    filesInDestinFolder = dir(folderName);
    if size(filesInDestinFolder,1)>0
        for i=3:size(filesInDestinFolder,1)
            if (strcmp(filesInDestinFolder(i).name,[LinearFileName '_' num2str(CalcComp) '.mat']) || ...
                    strcmp(filesInDestinFolder(i).name,[NonLinearFileName '_' num2str(CalcComp) '.mat']) )
                filesExist=true;
                break
            end
        end
    end
    % if files exist asks for confirmation to continue
    if filesExist
        calculateAnswer = questdlg([{'Existing File name.'};{'Are you sure you want to overwrite?'}],'Warning','Yes','No','No');
        if strcmp(calculateAnswer,'No')
            calculate=false;
        end
    end
end
if calculate
    if CalcComp==1
        handles.first_lc_file=[folderName '\' LinearFileName '_1'];
        handles.first_nlc_file=[folderName '\' NonLinearFileName '_1'];
        %prevents changes on destin files & foldes
        set(handles.dest_folder,'Enable','off');
        set(handles.linFile,'Enable','off');
        set(handles.nonLinFile,'Enable','off');
        set(handles.i_save_pp,'Enable','off');
        %creates file
        mkdir(folderName);
        xdata=handles.reducedData.dataMatrix';
        destinationFile=handles.first_lc_file;
        text='First';
    elseif(CalcComp==2)
        handles.second_lc_file=[folderName '\' LinearFileName '_2'];
        handles.second_nlc_file=[folderName '\' NonLinearFileName '_2'];
        xdata=handles.xdata1-handles.xi1;
        destinationFile=handles.second_lc_file;
        text='Second';
    elseif(CalcComp==3)
        handles.third_lc_file=[folderName '\' LinearFileName '_3'];
        handles.third_nlc_file=[folderName '\' NonLinearFileName '_3'];
        xdata=handles.xdata2-handles.xi2;
        destinationFile=handles.third_lc_file;
        text='Third';
    end
    l=size(xdata,1);
    cputime0 = cputime;
    % -----------------------------------------------------
    % Linear Principal Component Calculation
    Guiparam(handles);
    m = 1; testfrac = 0;
    fprintf(1,['\n\n###> ' text ' Linear mode with hidden neurons m = %3.0f:'],m);
    linear = 1;
    %nensemble = 7;
    [u,xi,W] = calcmode(xdata);
    save(destinationFile,'n','l','m','nbottle','xdata','u','xi','W','linear','initRand','nensemble',...
        'penalty','xscaling','xmean','xstd','utrain','xitrain','MSEx',...
        'ens_accept','ens_MSEx','ens_W');
    % save to disc file   (tx can be left out from the save command)
    fprintf(1,'\n#cputime = %12.4g\n',cputime-cputime0); cputime0=cputime;

    %------------------------------------------------------------------
    % NonLinear PCA
    Guiparam(handles); % read parameters again
    disp(['N-ensemble ' num2str(nensemble)]);
    fprintf(1,['\n\n###> ' text ' Nonlinear mode with number of hidden neurons m = %3.0f:\n'],m);
    [u,xi,W] = calcmode(xdata);

    %sets the file where to store the new nonlinear calculation data
    if CalcComp==1
        destinationFile=handles.first_nlc_file;
    elseif CalcComp==2
        destinationFile=handles.second_nlc_file;
    elseif CalcComp==3
        destinationFile=handles.third_nlc_file;
    end

    % saves to disc file
    save(destinationFile,'n','l','m','nbottle','xdata','u','xi','W','linear','initRand','nensemble',...
        'penalty','xscaling','xmean','xstd','utrain','xitrain','MSEx',...
        'ens_accept','ens_MSEx','ens_W');
    fprintf(1,'\n#cputime = %12.4g\n',cputime-cputime0); %cputime0=cputime;

    if CalcComp==1
        set(handles.see_1st_comp,'Enable','on');
        set(handles.see_all_button,'Enable','on');
        set(handles.pointsInNewSpace_button,'Enable','on');
        set(handles.saveButton,'Enable','on');

        handles.pointsInNewSpace = mapu(xdata,W);
        handles.pointsInNewSpace = [(1:length(handles.pointsInNewSpace)) ;handles.pointsInNewSpace];
        handles.xdata1=xdata;
        handles.xi1=xi;
    elseif CalcComp==2
        set(handles.see_2nd_comp,'Enable','on');
        handles.pointsInNewSpace(1,:) = []; %deletes 1st row who had indexes
        handles.pointsInNewSpace = [handles.pointsInNewSpace; mapu(xdata,W)];
        handles.xdata2=xdata;
        handles.xi2=xi;
    elseif CalcComp==3
        set(handles.see_3rd_comp,'Enable','on');
        set(handles.calculateNlpcaButton,'Enable','off');
        handles.pointsInNewSpace = [handles.pointsInNewSpace; mapu(xdata,W)];
    end

    guidata(hObject, handles);
end
%% GuiParam    
% Sets Parameters - based on param
function Guiparam(handles)
    
    global iprint isave linear nensemble testfrac segmentlength ...
  overfit_tol earlystop_tol xscaling penalty maxiter initRand ...
  initwt_radius options  n l m nbottle iter Jscale xmean xstd...
  ntrain xtrain utrain xitrain ntest xtest utest xitest MSEx ...
  ens_accept ens_MSEx ens_W ens_utrain ens_xitrain ens_utest...
  ens_xitest   

    nensemble = str2double(get(handles.nensemble_edit,'string'));
    penalty = str2double(get(handles.penalty_edit,'string'));
    m = str2double(get(handles.m_edit,'string'));
    segmentlength = str2double(get(handles.seglength_edit,'string'));
    initRand = str2double(get(handles.irand_edit,'string'));
    maxiter = str2double(get(handles.maxiter_edit,'string'));
    overfit_tol = str2double(get(handles.ovfit_tol_edit,'string'));
    earlystop_tol = str2double(get(handles.e_stop_tol_edit,'string'));
    initwt_radius = str2double(get(handles.wt_radius_edit,'string'));
    testfrac = str2double(get(handles.testfrac_edit,'string'));
    nbottle = str2double(get(handles.nbottle_edit,'string'));

    linear = get(handles.linear_pp,'value')-1;
    iprint = get(handles.iprint_pp,'value')-1;
    isave =  get(handles.i_save_pp,'value');
    xscaling = get(handles.xscale_pp,'value')-2;
    w = get(handles.warning_pp,'value');
    if w==1
        warning off;
    else
        warning on;
    end


%% Shows nonLinear Components  
% --- Executes on button press in see_1st_comp.
function see_1st_comp_Callback(hObject, eventdata, handles)
    plot_nlpca(handles.first_lc_file,handles.first_nlc_file);

% --- Executes on button press in see_2nd_comp.
function see_2nd_comp_Callback(hObject, eventdata, handles)
    plot_nlpca(handles.second_lc_file,handles.second_nlc_file);

% --- Executes on button press in see_3rd_comp.
function see_3rd_comp_Callback(hObject, eventdata, handles)
    plot_nlpca(handles.third_lc_file,handles.third_nlc_file);

%% shows one component
function showOneComponent(fileL,fileNl,nrCP,color)

    % Load linear Component
    load(fileL)

    xlin = xi; 
    % Locate the end coordinates of the line described by the linear mode.
    [xl(1,1),imax] = max(xlin(1,:)); [xl(1,2),imin] = min(xlin(1,:));
    xl(2,1) = xlin(2,imax); xl(2,2) = xlin(2,imin);
    xl(3,1) = xlin(3,imax); xl(3,2) = xlin(3,imin);

    % Load nonLinear Component
    load(fileNl)    
    if nrCP==1
        figure('Name','All NonLinear and Linear Components','numbertitle','off'); % plot the x variables
    end
    subplot(2,2,1);
    plot(xl(1,:),xl(2,:),['--' color],xi(1,:),xi(2,:),['o' color],'Markersize',4);
    if nrCP==1
        x= xdata;
        hold on
        plot(x(1,:),x(2,:),'.k','Linewidth',2);
        title('(a)','FontSize',13)
        xlabel('x_{1}','FontSize',12)
        ylabel('x_{2}','FontSize',12)
        grid on
    end

    subplot(2,2,2);
    plot(xl(1,:),xl(3,:),['--' color],xi(1,:),xi(3,:),['o' color],'Markersize',4);
    if nrCP==1    
        hold on
        plot(x(1,:),x(3,:),'.k','Linewidth',2);
        title('(b)','FontSize',13)
        xlabel('x_{1}','FontSize',12)
        ylabel('x_{3}','FontSize',12)
        grid on
    end

    subplot(2,2,3);
    plot(xl(2,:),xl(3,:),['--' color],xi(2,:),xi(3,:),['o' color],'Markersize',4);
    if nrCP==1    
        hold on
        plot(x(2,:),x(3,:),'.k','Linewidth',2);
        title('(c)','FontSize',13)
        xlabel('x_{2}','FontSize',12)
        ylabel('x_{3}','FontSize',12)
        grid on
    end

    subplot(2,2,4);
    plot3(xl(1,:),xl(2,:),xl(3,:),['--' color],xi(1,:),xi(2,:),xi(3,:),['o' color],'Markersize',4);
    if nrCP==1    
        hold on
        plot3(x(1,:),x(2,:),x(3,:),'.k','Linewidth',2);%,'color',[0,0.4,0]);
        view([-32.5,40]); %<<<<< change view angles for different 3-D perspective
        title('(d)','FontSize',13)
        xlabel('x_{1}','FontSize',12)
        ylabel('x_{2}','FontSize',12)
        zlabel('x_{3}','FontSize',12)
        box off; grid on;
    end
    legend('1st Linear Comp.','1st nlComponent','DataPoints','location','SouthEast');
    
   
%% Shows all components
function see_all_button_Callback(hObject, eventdata, handles)

    showOneComponent(handles.first_lc_file,handles.first_nlc_file,1,'r');

    if(strcmp(get(handles.see_2nd_comp,'Enable'),'on'))
        showOneComponent(handles.second_lc_file,handles.second_nlc_file,0,'g');
        legend('1st Linear Comp.','1st nlComponent','DataPoints','2nd Linear Comp.','2nd nlComponent'...
         ,'location','SouthEast');
    end
    if(strcmp(get(handles.see_3rd_comp,'Enable'),'on'))
        showOneComponent(handles.third_nlc_file,handles.third_nlc_file,0,'b');
        legend('1st Linear Comp.','1st nlComponent','DataPoints','2nd Linear Comp.','2nd nlComponent'...
               ,'3rd Linear Comp.','3rd nlComponent','location','SouthEast');
    end

%% shows points in new space    
% --- Executes on button press in pointsInNewSpace_button.
function pointsInNewSpace_button_Callback(hObject, eventdata, handles)
% hObject    handle to pointsInNewSpace_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    
    [l c]=size(handles.pointsInNewSpace);
    if isfield(handles.labels,'groups')
        if(l>1)
           PlotClusters(handles.pointsInNewSpace', handles.labels.groups.original, 'NonLinearPCA', 'Groups Plot', [], 0);
           labelCursor.data=handles.pointsInNewSpace;
        else
           data=[(1:c); handles.pointsInNewSpace];
           PlotClusters(data', handles.labels.groups.original, 'NonLinearPCA', 'Groups Plot', [], 0)
           grid on;
           labelCursor.data=data;
        end
    else
        figure('name','NonLinearPca','numbertitle','off')
        if(l==3)
            plot3(handles.pointsInNewSpace(1,:),handles.pointsInNewSpace(2,:),handles.pointsInNewSpace(3,:),'x');
            labelCursor.data=handles.pointsInNewSpace;
        else
            plot(handles.pointsInNewSpace(1,:),handles.pointsInNewSpace(2,:),'x')
            labelCursor.data=handles.pointsInNewSpace;
        end
        grid on
        title('Points in the new space');
    end
          
    labelCursor.labels=handles.labels;
    dcm_obj = datacursormode;
    set(dcm_obj,'DisplayStyle','datatip','SnapToDataVertex','on',...
        'Enable','on','UpdateFcn',{@myupdatefcn,labelCursor})

%% save button
% --- Executes on button press in saveButton.
function saveButton_Callback(hObject, eventdata, handles)
% hObject    handle to saveButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    uiresume(handles.figure1);

% % % % previous save to file code
%     % Save dialog
%     [a,b]=uiputfile('*.mat','Save Reduced Matrix and Clustering Results');
% 
%     if isequal([a,b],[0,0])
%         return
%     else
%         c=strcat(b,a);
%         % Get structures to save
%         labels = handles.labels;
%         reducedData = handles.reducedData;
%         % Save all structures:
%         save (c,'labels','reducedData')
%         % Update Info
%         msgbox('File Saved !');
%         
%     end

%% Labels Function    
function txt = myupdatefcn(empt,event_obj,extraInfo)
% get labels, data coordinates and clicked coordinates
labels=extraInfo.labels;
data=extraInfo.data;
%since coordinates is always a vector with 3 elements, add Z axis
if size(data,1)==2;
    data=[data; zeros(1,size(data,2))];
end
coordinates=event_obj.Position;

% check labels position for selected point
pos=0;
for i=1:size(data,2)
    if coordinates==data(:,i)'
        pos=i;
        break
    end
end
%pos = get(event_obj,'DataIndex');
if pos>0
    % format text to display
    nrOfLabels = length(labels.header);
    txt=cell(1,nrOfLabels);
    for i=1: nrOfLabels
        aux = [char(labels.header(i)) ': ' char(labels.(['Label_' num2str(i)])(pos))];
        txt(i) = {aux};
    end
else
    % format coordinates to display
    txt=cell(1,size(data,2));
    coord=[{'X: '},{'Y: '},{'Z: '}];
    for i=1: size(data,2)
        aux=[char(coord(i)) num2str(coordinates(i))];
        txt(i) = {aux};
    end
end

%% Fields Protections

%
% Normaly changed Values Group
%
function nensemble_edit_Callback(hObject, eventdata, handles)
    n = str2double(get(hObject,'String'));
    if n<0
        set(hObject,'String','0');
    end
    
function penalty_edit_Callback(hObject, eventdata, handles)

function m_edit_Callback(hObject, eventdata, handles)
    n = str2double(get(hObject,'String'));
    if n<0
        set(hObject,'String','0');
    end

%
% May be changed Group
%

function seglength_edit_Callback(hObject, eventdata, handles)
    n = str2double(get(hObject,'String'));
    if n<1
        set(hObject,'String','1');
    end
    
function irand_edit_Callback(hObject, eventdata, handles)
    n = str2double(get(hObject,'String'));
    if n<0
        set(hObject,'String','0');
    end    
    
function maxiter_edit_Callback(hObject, eventdata, handles)
    n = str2double(get(hObject,'String'));
    if n<1
        set(hObject,'String','1');
    end    

%
% Rarely Changed
%
    
function ovfit_tol_edit_Callback(hObject, eventdata, handles)
    n = str2double(get(hObject,'String'));
    if n<0
        set(hObject,'String','0');
    end    
    
function e_stop_tol_edit_Callback(hObject, eventdata, handles)
    n = str2double(get(hObject,'String'));
    if n<0
        set(hObject,'String','0');
    end    
    
function wt_radius_edit_Callback(hObject, eventdata, handles)
    n = str2double(get(hObject,'String'));
    if n<0
        set(hObject,'String','0');
    end
    
function TestFrac_edit_Callback(hObject, eventdata, handles)
    n = str2double(get(hObject,'String'));
    if n<0
        set(hObject,'String','0');
    elseif n>1
        set(hObject,'String','1');
    end

function nbottle_edit_Callback(hObject, eventdata, handles)
    n = str2double(get(hObject,'String'));
    if n<0
        set(hObject,'String','0');
    elseif n>3
        set(hObject,'String','3');
    end
    
%% MATLAB AUTOMATIC GENERATED CODE - CREATEFCN & CALLBACKS
function nensemble_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function m_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function ovfit_tol_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function e_stop_tol_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function wt_radius_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function TestFrac_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function nbottle_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function seglength_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

function irand_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function maxiter_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

function edit1_Callback(hObject, eventdata, handles)
function edit1_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

function penalty_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end        
    
function warning_pp_Callback(hObject, eventdata, handles)
function warning_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function linear_pp_Callback(hObject, eventdata, handles)
function linear_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function i_save_pp_Callback(hObject, eventdata, handles)
function i_save_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function iprint_pp_Callback(hObject, eventdata, handles)
function iprint_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function testfrac_edit_Callback(hObject, eventdata, handles)
function testfrac_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function linFile_Callback(hObject, eventdata, handles)
function linFile_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function dest_folder_Callback(hObject, eventdata, handles)
function dest_folder_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
function nonLinFile_Callback(hObject, eventdata, handles)
function nonLinFile_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end   
    
function xscale_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    













% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over calculateNlpcaButton.
function calculateNlpcaButton_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to calculateNlpcaButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


