function plot_nlpca(name_lin_file,name_nl_file)
% This function plots a linear and non
%
% plot_nlpca(name_lin_file,name_nl_file)
%
% - Input Arguments
%       name_lin_file - Name of the file where data about the linear
%                       component was automatically saved to.
%       name_nl_file - Name of the file where data about the non linear
%                      component was autocatically saved to.
%
% - No Output Arguments
%
%
% CLASSE Project
% Created by  Paulo Barbeiro - FCTUC
% paulobarbeiro@gmail.com / barbeiro@student.dei.uc.pt
% Updated July 13, 2007
%
% Copyright (C) 2007 Paulo Barbeiro  FCTUC Coimbra, Portugal

% ************************************************************************
% * Based on plmode1 and plmode2 functions from William W. Hsieh's work: *
% * Neuralnets for Multivariate And Time Series Analysis - (NeuMATSA)    *
% ************************************************************************
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
%

load(name_lin_file);
xlin = xi; 
% locate the end coordinates of the line described by the linear mode.
[xl(1,1),imax] = max(xlin(1,:)); [xl(1,2),imin] = min(xlin(1,:));
xl(2,1) = xlin(2,imax); xl(2,2) = xlin(2,imin);
xl(3,1) = xlin(3,imax); xl(3,2) = xlin(3,imin);

%loads file to plot out 
load(name_nl_file)
x= xdata;

figure('name',['Non Linear Component ' name_lin_file(length(name_lin_file))],'numbertitle','off');
subplot(2,2,1);
plot(xl(1,:),xl(2,:),'--',x(1,:),x(2,:),'x',xi(1,:),xi(2,:),'o','Markersize',4);
title('(a)','FontSize',13)
xlabel('x_{1}','FontSize',12)
ylabel('x_{2}','FontSize',12)
axis image;
grid on;

subplot(2,2,2);
plot(xl(1,:),xl(3,:),'--',x(1,:),x(3,:),'x',xi(1,:),xi(3,:),'o','Markersize',4);
title('(b)','FontSize',13)
xlabel('x_{1}','FontSize',12)
ylabel('x_{3}','FontSize',12)
axis image;
grid on;

subplot(2,2,3);
plot(xl(2,:),xl(3,:),'--',x(2,:),x(3,:),'x',xi(2,:),xi(3,:),'o','Markersize',4);
title('(c)','FontSize',13)
xlabel('x_{2}','FontSize',12)
ylabel('x_{3}','FontSize',12)
axis image;
grid on;

subplot(2,2,4);
axis image;
plot3(xl(1,:),xl(2,:),xl(3,:),'--b',xi(1,:),xi(2,:),xi(3,:),'or','Markersize',4);
hold on
plot3(x(1,:),x(2,:),x(3,:),'.','Linewidth',3,'color',[0,0.4,0]);
view([-32.5,40]); %<<<<< change view angles for different 3-D perspective
hold off

title('(d)','FontSize',13)
xlabel('x_{1}','FontSize',12)
ylabel('x_{2}','FontSize',12)
zlabel('x_{3}','FontSize',12)
box off; grid on;

end